<template>
${P.getPartCode(item,'FORM').code}
</template>

<script>
import  { FormButtonModel,FormDetailModel,FormItemModel,FormDRUIPartModel,FormGroupPanelModel,FormIFrameModel,FormPageModel,FormPartModel,FormRowItemModel,FormTabPageModel,FormTabPanelModel,FormUserControlModel}  from "@models/index.js";
import Schema from "async-validator";
import ComUtil from '@utils/ComUtil';
import AppService from "@service/AppService";
export default {
  
  name: "${ctrl.getCodeName()}${ctrl.getName()}",

  props:{
      formData:Object
  },

  watch: {
    'formData': {
      handler: 'onFormDataChanged',
      immediate: true,
      deep: true
    }
  },

  data() {
    return {

      /**
      * 当前语言
      *
      */
      local:"",
    
      /**
      * 激活分组
      *
      */
      activeGroup:[<#if ctrl.getAllPSDEFormDetails()??><#list ctrl.getAllPSDEFormDetails() as formitem><#if formitem.getDetailType() == "GROUPPANEL">"${formitem.getName()}",</#if></#list></#if>],
      
      /**
      * 激活分组
      *
      */
      data:{
        <#list ctrl.getPSDEFormItems() as item>
        ${item.getName()}: null,
        </#list>
      },

      /**
      * 表单模型
      *
      */
      detailsModel:{
        <#list ctrl.getAllPSDEFormDetails() as formdetail>
        ${formdetail.name}: ${P.getPartCode(formdetail, 'DETAIL_MODEL').code}, 
        </#list>
        <#if !ctrl.isNoTabHeader()>
        ${ctrl.name}: new FormTabPanelModel({ caption: '${ctrl.name}', detailType: 'TABPANEL', name: '${ctrl.name}', visible: true, isShowCaption: true, form: this, tabPages: [<#list ctrl.getPSDEFormPages() as formmenber><#if formmenber_index gt 0>, </#if>{ name: '${formmenber.name}', index: ${formmenber_index}, visible: <#if formmenber.getPSDEFDGroupLogic('PANELVISIBLE')??>false<#else>true</#if> }</#list>] }),
        </#if>
      },

      /**
      * 代码表模型
      *
      */      
      codelistModel:{
        <#if view.getAllRelatedPSCodeLists()??>
        <#list view.getAllRelatedPSCodeLists() as codelist>
        <#if codelist.getAllPSCodeItems()??>
        "${codelist.getSystemTag()}_${codelist.codeName}":[
        <#list codelist.getAllPSCodeItems() as codeItem>
        {"id":"${codeItem.getValue()}","text":"${codeItem.getText()}","disabled":${codeItem.isDisableSelect()?c}}<#if codeItem_has_next>,</#if>
        </#list>
        ]<#if codelist_has_next>,</#if>
        </#if>
        </#list>
        </#if>
      },

      /**
      *   表单值规则
      *
      */
      formRules:{
        aaaaaaaaaaaaaaaaaa
        <#if ctrl.getPSDEFormItemVRs()??>
          <#list ctrl.getPSDEFormItemVRs() as fideValueRule>
          qqqqqqqqqqqqqqqqqqqq
            <#if fideValueRule.getPSDEFValueRule()??>
            <#assign  fideValueRule = fideValueRule.getPSDEFValueRule()/>
            {<#if fideValueRule.getCodeName?? && fideValueRule.getCodeName()??>'getCodeName()':${fideValueRule.getCodeName()},</#if><#if fideValueRule.getRuleInfo?? &&  fideValueRule.getRuleInfo()??>'getRuleInfo()':${fideValueRule.getRuleInfo()},</#if><#if fideValueRule.getTypeDetail?? && fideValueRule.getTypeDetail()??>'getTypeDetail()':${fideValueRule.getTypeDetail()}</#if>}
            </#if>
          </#list>
        </#if>
      },

      /**
      * 默认值规则
      *
      */
      rules:{
        <#list ctrl.getAllPSDEFormDetails() as formdetail>
        <#if formdetail.getDetailType?? && formdetail.getDetailType() == 'FORMITEM'>
        ${formdetail.getName()}: [
            { type: '<#assign datatype=srfjavatype(formdetail.getStdDataType())><#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>number<#else>string</#if>', message: '${formdetail.getCaption()} 值必须为<#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>数值<#else>字符串</#if>类型', trigger: 'change' },
            { required: <#if formdetail.isAllowEmpty()>false<#else>true</#if>, type: '<#assign datatype=srfjavatype(formdetail.getStdDataType())><#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>number<#else>string</#if>', message: '${formdetail.getCaption()} 值不能为空', trigger: 'change' },
            { required: <#if formdetail.isAllowEmpty()>false<#else>true</#if>, type: '<#assign datatype=srfjavatype(formdetail.getStdDataType())><#if datatype=='BigInteger' || datatype=='Integer' || datatype=='Double'>number<#else>string</#if>', message: '${formdetail.getCaption()} 值不能为空', trigger: 'blur' },
        ],
        </#if>
        </#list>
      }
    };
  },

  created(){
        this.initForm();
        this.initlangu();
  },

  methods: {

    /**
     * 初始化表单
     *
     */
    initForm(){
        if(Object.keys(this.data).length >0){
             Object.keys(this.data).forEach((item) =>{
                     this.formItemChange(item,this.data[item],true);
             })   
        }
    },

    /**
     * 初始化语言
     * 
     */
    initlangu(){
        if (Object.is(window.localStorage.getItem("curLang"), "zh")) {
                this.local ="zh_CN";
        } else {
                this.local ="en_GB";
        }
        AppService.getInstance().subject.subscribe(res => {
            if (Object.is(res, "zh")) {
                this.local ="zh_CN";
            } else {
                this.local ="en_GB";
            }
        });
    },

    /**
     * 分页选中
     *
     */
    formPageSelected(key){
      console.log("表单选中了"+key);
    },

    /**
     *  按钮点击事件
     *
     */
    button_click($event,caption){
      this.$message.success("点击了"+caption);
    },

    /**
     * 表单项值变化
     *
     */
    formItemChange(name,value,isFirst){
      this.formLogic(name,value);
      if(!isFirst){
        this.validateItem(name, value);
        this.$emit('formItemChange',{name:name,value:value});
      }
    },

    /**
     * 校验单个表单项
     * @param item 
     * @param value 
     */
    validateItem(item, value) {
        // 做校验
        // 1.获取数值和规则
        const rule = this.rules[item];
        // 2.创建校验规则
        const schema = new Schema({ [item]: rule })
        // 校验返回Promise
        return schema.validate({ [item]: value },undefined,errors => {
            if (errors) {
                // 有错
                this.detailsModel[item].setError(errors[0].message);
            } else {
                this.detailsModel[item].setError('');
            }
        })
    },

    /**
     * 校验表单
     * 
     * @memberof Main
     */
     validateForm(callback) {
        let tasks;
        if (Object.keys(this.data).length > 0) {
            tasks = Object.keys(this.data).map((item) => {
                this.validateItem(item, this.data[item]);
            })
        }
        Promise.all(tasks)
            .then(() => callback(true))
            .catch(() => callback(false))
    },

    /**
     * 表单逻辑
     *
     */
    formLogic( name, newVal, oldVal) {
      <#if P.getPartCode(item,'FORM_LOGIC').code?length gt 0>
      ${P.getPartCode(item,'FORM_LOGIC').code}
      </#if>
      <#if ctrl.getPSDEFormItems()??>
      <#list ctrl.getPSDEFormItems() as formitem>
      <#if formitem.getPSDEFormItemUpdate()??>
      if(Object.is(name, '${formitem.name}')){
          this.updateFormItems('${formitem.getPSDEFormItemUpdate().codeName}', this.data,false);
      }
      </#if>
      </#list>
      </#if>
    },

    onFormDataChanged(val,oldVal){
        if(val && val !== oldVal){
                Object.keys(this.data).forEach(item =>{
                        this.data[item] = null;
                })
                Object.assign(this.data,val);
        }
    }
  }
}
</script>
<style scoped>

</style>
